<template>
	<v-row class="search-box" align="center">
		<v-col :cols="option.labelCols" class="py-0">
			<label for="" class="search-box-label">
				<v-icon v-if="item.iconShow" small
					:class="['mr-1', item.required ? 'icon-orange' : 'icon-blue']">$icoBulletPoint</v-icon>
				{{ option.labelContent }}
			</label>
		</v-col>
		<v-col :cols="option.textCols" class="py-0">
			<v-text-field readonly v-model="selectValue" append-icon="" class="v-input__custom"
				@click="dialogOpenCloseEvent(dialog)" outlined :hide-details="true" :required="item.required || false"
				:disabled="item.disabled || false"><template v-slot:append>
					<!-- Custom SVG icon -->
					<v-icon>$icoSearch</v-icon>

				</template></v-text-field>
		</v-col>

		<v-dialog v-model="dialog" scrollable width="800px">
			<v-card style="height: 100%">
				<v-card-title class="px-6 py-4 d-flex align-center justify-space-between">
					<span class="custom-title-4">{{ option.modalTitle }}</span>
					<a-button icon="close" type="text" @click="dialogOpenCloseEvent(dialog)"></a-button>
				</v-card-title>
				<div class="pa-6 pt-0 pb-3">
					<v-row align="center">
						<v-col :cols="5">
							<component :is="'SelectBox'" ref="SelectBox1" :labelCols="12" :textCols="12"
								:iconShow="true" :propsValue="selectValue01" :itemList="selectValueList01"
								:label="'설비그룹'" @update:propsValue="selectValue01 = $event" :readonly="item.openMode == undefined
									? openMode
									: item.openMode == 'ALL'
										? false
										: true
									" />
						</v-col>
						<v-col :cols="7">
							<v-row align="center" no-gutters>
								<v-col :cols="12">
									<label for="" class="search-box-label">
										<v-icon small :class="['mr-1 icon-blue']">$icoBulletPoint</v-icon>
										물리량명
									</label>
								</v-col>
								<v-col :cols="10" class="pr-2"> <v-text-field append-icon="" class="v-input__custom" outlined
										:hide-details="true" v-model="searchWord" @keyup.enter="search"><template
											v-slot:append>
											<!-- Custom SVG icon -->
											<v-icon>$icoSearch</v-icon>


										</template></v-text-field></v-col>
								<v-col cols="2" class="text-right">
									<a-button icon="search" type="primary" @click="search()"
										class="search-button">조회</a-button>

								</v-col>
							</v-row>
						</v-col>
					</v-row>

				</div>
				<!-- <div :style="'height: calc(50vh)'"> -->
				<div :style="{ height: 'calc(100% - 60px)' }">
					<!-- <div :style="{ height: 'calc(100% - 213px)' }"> -->
					<div ref="modalGridParent" class="px-6 py-4">
						<component :is="loadGrid && dialog ? 'Grid' : null" :gridName="gridName"
							:dataPath="searchParam.modalDataEqpmBaseInfoPop.eqpmBaseInfoPop"
							:parentPrgmId="parentPrgmId" @getRowsData="getRowData" @dblClick="setUpdate($event)" />
					</div>
				</div>
				<v-card-actions class="px-6 py-4 d-flex align-center justify-end">
					<a-button :ripple="false" @click="dialogOpenCloseEvent(dialog)" class="mr-2">닫기</a-button>
					<a-button :ripple="false" type="primary" @click="setUpdate($event)">확인</a-button>

				</v-card-actions>
			</v-card>
		</v-dialog>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import Grid from '~/components/common/Grid';
import Utility from '~/plugins/utility';
import SelectBox from '@/components/common/select/SelectBox';

export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
		labelContent: {
			type: String,
			require: false,
			default: '설비 선택',
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		modalTitle: {
			type: String,
			require: false,
			default: '설비 선택',
		},
		modalContent: {
			type: String,
			require: false,
			default: '검색',
		},
		item: {
			type: Object,
			require: false,
		},
		bindingData: {
			type: String,
			require: false,
		},
		openMode: {
			type: Boolean,
			require: false,
			default: true, // 'ALL'도 있음
		},
		iconShow: {
			type: Boolean,
			require: false,
			default: true,
		},
		// bindingFlag:{
		//   type:Boolean,
		//   require: false,
		//   default: false
		// }
	},
	components: {
		Grid,
		Utility,
		SelectBox,
	},
	data() {
		return {
			dialog: false,

			loadGrid: true,
			gridName: 'gridEqpmBaseInfoPop',
			myModalKey: 'eqpmBaseInfoPop',
			modalDataKey: 'modalDataEqpmBaseInfoPop',

			searchWord: '',
			selectedData: {},
			textFieldData: '',
			selectValue01: null,
			selectValueList01: [],
			option: {
				labelCols:
					this.item !== undefined
						? this.item.labelCols !== undefined
							? this.item.labelCols
							: this.labelCols
						: this.labelCols,
				labelContent:
					this.item !== undefined
						? this.item.labelContent !== undefined
							? this.item.labelContent
							: this.labelContent
						: this.labelContent,
				textCols:
					this.item !== undefined
						? this.item.textCols !== undefined
							? this.item.textCols
							: this.textCols
						: this.textCols,
				modalTitle:
					this.item !== undefined
						? this.item.modalTitle !== undefined
							? this.item.modalTitle
							: this.modalTitle
						: this.modalTitle,
			},
			bindingGridEqpmIdList: [],
		};
	},
	computed: {
		...mapState({
			searchParam(state) {
				return state.pageData[this.parentPrgmId];
			},
			myBindingData(state) {
				if (!this.bindingData) {
					return state.pageData[this.parentPrgmId]['rowGridSelectData'];
				} else {
					return state.pageData[this.parentPrgmId][this.bindingData][
						'rowGridSelectData'
					];
				}
			},
			nowGridEqpmIdList(state) {
				return state.pageData[this.parentPrgmId]['nowGridEqpmIdList'];
			},
		}),
		selectValue: {
			get() {
				if (!this.item) {
					return this.textFieldData;
				}
				// else if(this.item.disableContent){
				//   return "NONE";
				// }
				else {
					return this.myBindingData
						? this.myBindingData[this.item.valueNm]
						: this.textFieldData;
				}
			},
			set(value) {
				// if(this.item && this.item.disableContent){
				//   return "NONE";
				// }
				return value;
			},
		},
	},
	watch: {
		async dialog(val) {
			if (val) {
				await this.setSelectValueList01();
				await this.getGridData();
			}
		},
		async selectValue01(value) {
			await this.search();
		},
		nowGridEqpmIdList(value) {
			this.bindingGridEqpmIdList = value;
		},
	},

	beforeCreate() {
		this.$store.commit('setPageData', {
			modalDataEqpmBaseInfoPop: { eqpmBaseInfoPop },
		});
	},
	async created() {
		await this.init();
	},
	mounted() { },
	methods: {
		...mapMutations({
			setPageData: 'setPageData',
			setModalGridData: 'setModalGridData',
			setModalGridColumn: 'setModalGridColumn',
			setModalGridOption: 'setModalGridOption',
		}),
		...mapActions({
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
		}),
		async init() {
			await this.setSelectValueList01();
			this.gridInit();
		},
		async setSelectValueList01() {
			let res = await this.postApiReturn({
				apiKey: 'selectEqpmGrpCodeList',
				resKey: 'eqpmGrpCodeLists',
				sendParam: { eqpmKindId: this.searchParam.eqpmKindId },
				// 부모 페이지에서 설비종류인 eqpmKindId 값을 꼭 가져와야한다.
			});
			if (res.length > 0) {
				this.selectValueList01 = await res.map(obj => {
					return {
						text: obj.eqpmGrpNm,
						value: obj.eqpmGrpId,
					};
				});
				// 부모 페이지에서 설비그룹을 선택한 값이 있다면(eqpmGrpId) 그 값으로 바인딩 아닐 경우 조회한 데이터의 첫번째 값으로 선택
				this.selectValue01 =
					this.searchParam.eqpmGrpId != undefined
						? this.searchParam.eqpmGrpId
						: this.selectValueList01[0].value;
				// this.selectValue01 = this.selectValueList01[0].value;
			} else {
				this.selectValueList01 = [];
				this.selectValue01 = null;
			}

		},
		search() {
			this.getGridData();
		},
		initSearch() {
			this.searchWord = '';
			this.getGridData();
		},
		gridInit() {
			const myOptions = {
				columnOptions: {
					resizable: true,
				},
			};
			this.setModalGridOption({
				modalKey: this.myModalKey,
				gridKey: this.gridName,
				modalDataKey: this.modalDataKey,
				value: Object.assign(
					// Utility.defaultGridOption(this.$refs.modalGridParent.offsetHeight - 60, myOptions),
					Utility.defaultGridOption(390, myOptions),
					myOptions,
				),
			});

			this.setModalGridColumn({
				modalKey: this.myModalKey,
				gridKey: this.gridName,
				modalDataKey: this.modalDataKey,
				value: [
					{ header: '설비ID', name: 'eqpmId', align: 'left' },
					{ header: '설비명', name: 'eqpmNm', align: 'left' },
				],
			});
		},
		async getGridData() {
			this.loadGrid = false;

			let res = await this.postApiReturn({
				apiKey: 'selectEqpmBaseInfoPop',
				resKey: 'epqmBaseInfoData',
				sendParam: {
					eqpmGrpId: this.selectValue01,
					searchWord: this.searchWord,
					// openMode : this.item.openMode == undefined ? this.openMode : this.item.openMode
				},
			});
			// grid와 popup eqpmId 값 중복되는 것 제거하는 로직 - 시작
			let newRes = [];
			if (this.bindingGridEqpmIdList.length > 0) {
				newRes = res.filter(item => {
					return !this.bindingGridEqpmIdList.includes(item.eqpmId);
				});
				res = newRes;
			}
			// grid와 popup eqpmId 값 중복되는 것 제거하는 로직 - 끝

			this.setModalGridData({
				modalKey: this.myModalKey,
				gridKey: this.gridName,
				modalDataKey: this.modalDataKey,
				value: res,
			});

			this.loadGrid = true;
		},
		getRowData(data) {
			this.selectedData = { ...data };
		},
		setUpdate(v) {
			// 그리드와 popup eqpmId값 비교하는 로직 지금은 안씀
			// let res = this.checkDuplicateEqpmId();
			// if(res.includes(this.selectedData.eqpmId)){
			// 	alert('가이드 지표에 이미 등록된 설비입니다.');
			// 	return;
			// };
			this.dialog = false;
			if (!this.item) {
				this.textFieldData = this.selectedData.eqpmId;
			} else {
				//grid와 popup 겹치는 eqpmId값 수정하는 로직 - 시작
				let tempBindingGridEqpmIdList = this.bindingGridEqpmIdList;
				let idx = tempBindingGridEqpmIdList.indexOf(this.myBindingData.eqpmId);
				if (idx < 0) {
					tempBindingGridEqpmIdList.push(this.selectedData.eqpmId);
				} else {
					tempBindingGridEqpmIdList[idx] = this.selectedData.eqpmId;
				}
				this.setPageData({ nowGridEqpmIdList: tempBindingGridEqpmIdList });
				//grid와 popup 겹치는 eqpmId값 수정하는 로직 - 끝
				if (this.item.bindNm) {
					this.myBindingData[this.item.bindNm] = this.selectedData.eqpmId;
				} else {
					this.myBindingData.eqpmId = this.selectedData.eqpmId;
				}
				// this.myBindingData.calcDesc = this.selectedData.calcDesc;
				const dt = {
					columnName: this.item.valueNm,
					value: this.selectedData.eqpmId,
				};
				this.$emit('gridEditingFinish', dt);
				if (this.item.valueNm2 !== undefined) {
					const dt = {
						columnName: this.item.valueNm2,
						value: this.selectedData[this.item.valueNm2],
					};
					this.$emit('gridEditingFinish', dt);
				}
				if (this.item.bindNm !== undefined) {
					const dt = {
						columnName: this.item.bindNm,
						value: this.selectedData.eqpmId,
					};
					this.$emit('gridEditingFinish', dt);
				}
			}
		},
		checkDuplicateEqpmId() {
			let gridData = this.searchParam.rowGrid.data;
			let res = gridData.map(item => {
				return item.eqpmId;
			});
			return res;
		},
		dialogOpenCloseEvent(val) {
			// if(this.item && this.item.disableContent){
			//   this.dialog = false;
			//   return;
			// }
			if (this.myBindingData.length <= 0) {
				return alert('설비상세 리스트를 먼저 선택해주세요.');
			}
			this.dialog = !val;
		},
	},
};

var eqpmBaseInfoPop = {
	gridEqpmBaseInfoPop: {
		data: [],
		column: [],
		option: {},
	},
};
</script>

<style lang="scss" scoped>
::v-deep {
	.v-dialog {
		overflow-y: hidden !important;
	}

	.tui-grid-table-container {
		.tui-grid-table {
			border-right-style: solid !important;
			border-right-color: rgba(255, 255, 255, 0.1) !important;
		}
	}

	.tui-grid-cell.tui-grid-cell-has-tree .tui-grid-tree-extra-content+.tui-grid-cell-content:before {
		content: none !important;
	}
}

@each $theme in dark, light {
	// .v-application.#{$theme}-mode {
	// 	.v-dialog {
	// 		.v-card {
	// 			&__title {


	// 				@if $theme ==dark {
	// 					background-color: #2d3355;

	// 					.v-btn {
	// 						background-color: #2d3355;
	// 					}
	// 				}

	// 			}
	// 		}
	// 	}
	// }
}
</style>
